H=-3000;

dxx1=2;
dyy1=2;
xx1=0;
yy1=-84+dyy1/2:dyy1:84-dyy1/2;

tt1=H*ones(length(yy1),1);

tt1(1)=0;
tt1(end)=0;
fid=fopen('no_land.bin','w','b'); fwrite(fid,tt1','real*8'); fclose(fid);

%calculate total geothermal assuming mean of 0.1 W/m^2
area=0.1*sum(cos(yy1(2:end-1)/180*pi));

w=7;
tt1=H-tt1.*exp(-(yy1').^2/w^2)/2;
plot(yy1,tt1,'-o');

tt1(1)=0;
tt1(end)=0;
fid=fopen('equator_ridge.bin','w','b'); fwrite(fid,tt1','real*8'); fclose(fid);

tt2=zeros(length(yy1),1);
r1=42:43;
tt2(r1)=area/sum(cos(yy1(r1)/180*pi));
tt2(r1)
fid=fopen('equator_ridge_GT.bin','w','b'); fwrite(fid,tt2','real*8'); fclose(fid);

% following the literature there is a factor 4 between the heating at the
% ridges and the background heating 
tt3=1+3*exp(-(yy1').^2/w^2);
tt3(1)=0;
tt3(end)=0;
cc=sum(tt3(2:end-1)'.*cos(yy1(2:end-1)/180*pi))/sum(cos(yy1(2:end-1)/180*pi));
tt3=tt3/cc*0.1;
sum(tt3(2:end-1)'.*cos(yy1(2:end-1)/180*pi))/sum(cos(yy1(2:end-1)/180*pi))

figure;
plot(tt3,'-o');
title('geothermal heating in W/m^2');
fid=fopen('equator_ridge_GT_factor4.bin','w','b'); fwrite(fid,tt3','real*8'); fclose(fid);

tt1=H*ones(length(yy1),1);
w=7;
tt1=H-tt1.*exp(-(yy1'-20).^2/w^2)/2;
figure;
plot(tt1,'-o');

tt1(1)=0;
tt1(end)=0;
fid=fopen('off_equator_ridge.bin','w','b'); fwrite(fid,tt1','real*8'); fclose(fid);

tt2=zeros(length(yy1),1);
r1=52:53;
tt2(r1)=area/sum(cos(yy1(r1)/180*pi));
tt2(r1)
fid=fopen('off_equator_ridge_GT.bin','w','b'); fwrite(fid,tt2','real*8'); fclose(fid);

% following the literature there is a factor 4 between the heating at the
% ridges and the background heating 
tt3=1+3*exp(-(yy1'-20).^2/w^2);
tt3(1)=0;
tt3(end)=0;
cc=sum(tt3(2:end-1)'.*cos(yy1(2:end-1)/180*pi))/sum(cos(yy1(2:end-1)/180*pi));
tt3=tt3/cc*0.1;
sum(tt3(2:end-1)'.*cos(yy1(2:end-1)/180*pi))/sum(cos(yy1(2:end-1)/180*pi))

figure;
plot(tt3,'-o');
title('geothermal heating in W/m^2');
fid=fopen('off_equator_ridge_GT_factor4.bin','w','b'); fwrite(fid,tt3','real*8'); fclose(fid);

%% calculate sea-ice thickness based on geothermal balance assumption
% read Pollard surface data
aa=load('/n/tzipermanfs1/ashkena/Snowball-oceanography/Input/Pollard/lat_Ts_pme_81S_81N.txt');
% calculate mean Ts
Ts=sum(aa(:,2)'.*cos(yy1(2:end-1)/180*pi))/sum(cos(yy1(2:end-1)/180*pi));
Ts

rhoI=920;  % density of ice
rho0=1040;  % approximate density of sea water
CpI=2000;  % heat capacity of ice
kappa_I=1.54e-6; % heat cond. of ice 
Tf=-3.53;   % approximate freezing temp.
Q=0.1;    % bottom geothermal heating 
mu=rhoI/rho0;
h=rhoI*CpI*kappa_I*mu*(Ts-Tf)/Q
Ts1=Tf+mu*(Ts-Tf);
Ts1

fid=fopen('si_topo_uniform1.bin','w','b'); fwrite(fid,(h+0*tt3)','real*8'); fclose(fid);

fid=fopen('si_topo_uniform_Ts.bin','w','b'); fwrite(fid,(Ts1+0*tt3)','real*8'); fclose(fid);
