%% prepare hotspots file 

dlon=2;
dlat=2;
lon=0;
lat=-84+dlat/2:dlat:84-dlat/2;

area=zeros([length(lon) length(lat)]);

r=6370000;
dy=r*dlat/180*pi;
dx=r*cos(lat/180*pi)*dlon/180*pi;

for i=1:length(lat)
    area(:,i)=dy*dx(i);
end

%% read bathy 

fid = fopen('no_land.bin','r','b'); tt1=fread(fid,size(area),'real*8'); fclose(fid);

% compute land area; exclude land points at the south/north margins

s_tot=sum(sum(area(:,2:(end-1))));
tt2=tt1;
tt2(find(tt1<0))=1;

s_ocean=sum(sum(tt2.*area));

% mean hotspot radiattion 50 mW
hs=100*1e-3;

hs_new=hs*s_tot/s_ocean;

hs_array=zeros(size(area));

hs_array(find(tt1<0))=hs_new;

%contourf(lon,lat,hs_array');colorbar;
%return;

fid=fopen('hotspots_uniform100mW.bin','w','b'); fwrite(fid,hs_array,'real*8'); fclose(fid);

