C $Header: /u/gcmpack/MITgcm/pkg/geothermal/geothermal_check.F,v 1.5 2009/12/27 23:40:03 jmc Exp $
C $Name: checkpoint63 $

#include "GEOTHERMAL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: GEOTHERMAL_CHECK

C !INTERFACE:
      SUBROUTINE GEOTHERMAL_CHECK( myThid )

C     !DESCRIPTION:
C     Check dependances with other packages

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GEOTHERMAL.h"

C     !INPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_GEOTHERMAL
C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

       WRITE(msgBuf,'(A)') 'GEOTHERMAL_CHECK: #define GEOTHERMAL'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

C--  Print out some kee parameters :
c       CALL WRITE_0D_L( geothermal_StaV_Cgrid, INDEX_NONE,
c     &  'geothermal_StaV_Cgrid =', ' /* state vector on C-grid */')
       CALL WRITE_0D_L( geothermal_Tend_Cgrid, INDEX_NONE,
     &  'geothermal_Tend_Cgrid =', ' /* vector tendency on C-grid */')
       CALL WRITE_0D_L( geothermal_applyTendT, INDEX_NONE,
     &  'geothermal_applyTendT =',
     &  ' /* apply GEOTHERMAL tendency to Temperature Eq.*/')
c       CALL WRITE_0D_L( geothermal_applyTendS, INDEX_NONE,
c     &  'geothermal_applyTendS =',
c     &  ' /* apply GEOTHERMAL tendency to Salinity Eq.*/')
c       CALL WRITE_0D_L( geothermal_applyTendU, INDEX_NONE,
c     &  'geothermal_applyTendU =',
c     &  ' /* apply GEOTHERMAL tendency to U momentum Eq.*/')
c       CALL WRITE_0D_L( geothermal_applyTendV, INDEX_NONE,
c     &  'geothermal_applyTendV =',
c     &  ' /* apply GEOTHERMAL tendency to V momentum Eq.*/')
C-   add some other as example:
c       CALL WRITE_0D_I( geothermal_index1, INDEX_NONE, ' geothermal_index1 =',
c     &  ' /* user defined parameter */')
c       CALL WRITE_0D_RL( geothermal_param1, INDEX_NONE, ' geothermal_param1 =',
c     &  ' /* user defined parameter */')
       CALL WRITE_0D_C( geothermal_bottomFile,-1,INDEX_NONE,
     & 'geothermal_bottomFile =',
     &  ' /* filename with power of ocean bottom geothermal heating */')

C--  Check parameters:


C-     Put stops here if some flags are wrongly chosen.
C-     For example, require this package to use tempStepping
c$$$       IF ( .NOT.tempStepping .AND. geothermal_applyTendT ) THEN
c$$$        WRITE(msgBuf,'(A)') 'An example requirement is:'
c$$$        CALL PRINT_ERROR( msgBuf , 1)
c$$$        WRITE(msgBuf,'(A)') 'geothermal_applyTendT needs tempStepping=.true.'
c$$$        CALL PRINT_ERROR( msgBuf , 1)
c$$$        STOP 'ABNORMAL END: S/R GEOTHERMAL_CHECK'
c$$$       ENDIF

      _END_MASTER(myThid)

#endif /* ALLOW_GEOTHERMAL */

      RETURN
      END
