C $Header: /u/gcmpack/MITgcm/pkg/geothermal/geothermal_init_fixed.F,v 1.2 2006/08/07 21:13:52 edhill Exp $
C $Name: checkpoint63 $

#include "GEOTHERMAL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: GEOTHERMAL_INIT_FIXED

C !INTERFACE:
      SUBROUTINE GEOTHERMAL_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize GEOTHERMAL variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GEOTHERMAL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
#ifdef ALLOW_DIAGNOSTICS
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
#endif /* ALLOW_DIAGNOSTICS */

c$$$#ifdef ALLOW_MNC
c$$$      IF (useMNC) THEN
c$$$        CALL GEOTHERMAL_MNC_INIT( myThid )
c$$$      ENDIF
c$$$#endif /* ALLOW_MNC */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       diagName  = 'HSBotFlx'
       diagTitle = 'Geothermal bottom flux'
       diagUnits = 'W/m^2           '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
C        CALL GEOTHERMAL_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END
