C $Header: /u/gcmpack/MITgcm/pkg/geothermal/geothermal_readparms.F,v 1.4 2009/12/27 23:40:03 jmc Exp $
C $Name: checkpoint63 $

#include "GEOTHERMAL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: GEOTHERMAL_READPARMS

C !INTERFACE:
      SUBROUTINE GEOTHERMAL_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize GEOTHERMAL variables and constants.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GEOTHERMAL.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_GEOTHERMAL

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit

      NAMELIST /GEOTHERMAL_PARM01/
     &       geothermal_Tend_Cgrid,
     &       geothermal_applyTendT,
     &       geothermal_bottomFile

      _BEGIN_MASTER(myThid)

C--   Default values for GEOTHERMAL
      geothermal_Tend_Cgrid  = .TRUE.
      geothermal_applyTendT  = .TRUE.
C-    additional parameters:
C-    file names for initial conditions:
      geothermal_bottomFile   = ' '

      WRITE(msgBuf,'(A)') 
     & 'GEOTHERMAL_READPARMS: opening data.geothermal'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                  'data.geothermal', 'GEOTHERMAL_READPARMS',
     O                  iUnit,
     I                  myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=GEOTHERMAL_PARM01)
      WRITE(msgBuf,'(A)')
     &    'GEOTHERMAL_READPARMS: finished reading data.geothermal'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)
C     Close the open data file
      CLOSE(iUnit)

C     Make sure that we locally honor the global MNC on/off flag
c      geothermal_MDSIO = (.NOT. geothermal_MNC) .OR. outputTypesInclusive

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_GEOTHERMAL */

      RETURN
      END
